!     Last change:  WRG  25 Apr 2005   10:45 am
module gammafn
implicit none
contains

	FUNCTION gammln_s(xxk)
	IMPLICIT NONE
	REAL(8), INTENT(IN) :: xxk
	REAL(8) :: gammln_s
	REAL(8) :: tmp,x
	REAL(8) :: stp = 2.5066282746310005_8
	REAL(8), DIMENSION(6) :: coef = (/76.18009172947146_8,&
		-86.50532032941677_8,24.01409824083091_8,&
		-1.231739572450155_8,0.1208650973866179e-2_8,&
		-0.5395239384953e-5_8/)
	if(xxk.le.0.D0)then
	print*,'gammln_s arg improper'
	stop
	endif
	x=xxk
	tmp=x+5.5_8
	tmp=(x+0.5_8)*log(tmp)-tmp
	gammln_s=tmp+log(stp*(1.000000000190015_8+&
		sum(coef(:)/arth(x+1.0_8,1.0_8,size(coef))))/x)
	END FUNCTION gammln_s


	FUNCTION gammln_v(xxk)
	IMPLICIT NONE
	REAL(8), DIMENSION(:), INTENT(IN) :: xxk
	INTEGER(4) :: i,compre(size(xxk,1))
	REAL(8), DIMENSION(size(xxk)) :: gammln_v
	REAL(8), DIMENSION(size(xxk)) :: ser,tmp,x,y
	REAL(8) :: stp = 2.5066282746310005_8
	REAL(8), DIMENSION(6) :: coef = (/76.18009172947146_8,&
		-86.50532032941677_8,24.01409824083091_8,&
		-1.231739572450155_8,0.1208650973866179e-2_8,&
		-0.5395239384953e-5_8/)
	if (size(xxk) == 0) RETURN
        do i=1,size(xxk,1)
           if(xxk(i).le.0.D0)compre(i)=1
        enddo

	if(dot_product(compre,compre).gt.0)then
	print*,'gammln_v args improper'
	stop
	endif
	x=xxk
	tmp=x+5.5_8
	tmp=(x+0.5_8)*log(tmp)-tmp
	ser=1.000000000190015_8
	y=x
	do i=1,size(coef)
		y=y+1.0_8
		ser=ser+coef(i)/y
	end do
	gammln_v=tmp+log(stp*ser/x)
	END FUNCTION gammln_v

	FUNCTION arth(first,increment,n)
	REAL(8), INTENT(IN) :: first,increment
	INTEGER(4), INTENT(IN) :: n
	REAL(8), DIMENSION(n) :: arth
	INTEGER(4) :: k,k2
	REAL(8) :: temp
	INTEGER(4), PARAMETER :: NPAR_ARTH=16,NPAR2_ARTH=8
	
	if (n > 0) arth(1)=first
	if (n <= NPAR_ARTH) then
		do k=2,n
			arth(k)=arth(k-1)+increment
		end do
	else
		do k=2,NPAR2_ARTH
			arth(k)=arth(k-1)+increment
		end do
		temp=increment*NPAR2_ARTH
		k=NPAR2_ARTH
		do
			if (k >= n) exit
			k2=k+k
			arth(k+1:min(k2,n))=temp+arth(1:min(k,n-k))
			temp=temp+temp
			k=k2
		end do
	end if
	END FUNCTION arth
end module gammafn
